// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function IsValidNorwegianPersonalIdentificationNumber(fnummer){
  var gyldig;
  var d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11;
  var aDatetimeDate;
  var k1, k2;
  var failures;
  var errorMessage;

  errorMessage = CreateStringReference("".split(''));

  if(fnummer.length == 11){
    failures = CreateNumberReference(0);

    d1 = CharToNumberWithCheck(fnummer[0], failures);
    d2 = CharToNumberWithCheck(fnummer[1], failures);
    d3 = CharToNumberWithCheck(fnummer[2], failures);
    d4 = CharToNumberWithCheck(fnummer[3], failures);
    d5 = CharToNumberWithCheck(fnummer[4], failures);
    d6 = CharToNumberWithCheck(fnummer[5], failures);
    d7 = CharToNumberWithCheck(fnummer[6], failures);
    d8 = CharToNumberWithCheck(fnummer[7], failures);
    d9 = CharToNumberWithCheck(fnummer[8], failures);
    d10 = CharToNumberWithCheck(fnummer[9], failures);
    d11 = CharToNumberWithCheck(fnummer[10], failures);

    if(failures.numberValue == 0){
      aDatetimeDate = GetDateFromNorwegianPersonalIdentificationNumber(fnummer, failures);

      if(datetimeIsValidDate(aDatetimeDate, errorMessage)){
        if(failures.numberValue == 0){
          k1 = d1*3 + d2*7 + d3*6 + d4*1 + d5*8 + d6*9 + d7*4 + d8*5 + d9*2;
          k1 = k1%11;
          if(k1 != 0){
            k1 = 11 - k1;
          }
          if(k1 == 10){
            failures.numberValue = failures.numberValue + 1;
          }

          k2 = d1*5 + d2*4 + d3*3 + d4*2 + d5*7 + d6*6 + d7*5 + d8*4 + d9*3 + k1*2;
          k2 = k2%11;
          if(k2 != 0){
            k2 = 11 - k2;
          }
          if(k2 == 10){
            failures.numberValue = failures.numberValue + 1;
          }

          if(k1 == d10 && k2 == d11 && failures.numberValue == 0){
            gyldig = true;
          }else{
            gyldig = false;
          }
        }else{
          gyldig = false;
        }
      }else{
        gyldig = false;
      }
    }else{
      gyldig = false;
    }
  }else{
    gyldig = false;
  }

  return gyldig;
}
function GetDateFromNorwegianPersonalIdentificationNumber(fnummer, failures){
  var aDatetimeDate;
  var individnummer;
  var day, month, year;
  var d1, d2, d3, d4, d5, d6, d7, d8, d9;

  aDatetimeDate = {};

  d1 = CharToNumberWithCheck(fnummer[0], failures);
  d2 = CharToNumberWithCheck(fnummer[1], failures);
  d3 = CharToNumberWithCheck(fnummer[2], failures);
  d4 = CharToNumberWithCheck(fnummer[3], failures);
  d5 = CharToNumberWithCheck(fnummer[4], failures);
  d6 = CharToNumberWithCheck(fnummer[5], failures);
  d7 = CharToNumberWithCheck(fnummer[6], failures);
  d8 = CharToNumberWithCheck(fnummer[7], failures);
  d9 = CharToNumberWithCheck(fnummer[8], failures);

  if(failures.numberValue == 0){
    /* Individnummer */
    individnummer = d7*100 + d8*10 + d9;

    /* Make date */
    day = d1*10 + d2;
    month = d3*10 + d4;
    year = d5*10 + d6;

    if(individnummer >= 0 && individnummer <= 499){
      year = year + 1900;
    }else if(individnummer >= 500 && individnummer <= 749 && year >= 54 && year <= 99){
      year = year + 1800;
    }else if(individnummer >= 900 && individnummer <= 999 && year >= 40 && year <= 99){
      year = year + 1900;
    }else if(individnummer >= 500 && individnummer <= 999 && year >= 0 && year <= 39){
      year = year + 1900;
    }else{
      failures.numberValue = failures.numberValue + 1;
    }

    aDatetimeDate.year = year;
    aDatetimeDate.month = month;
    aDatetimeDate.day = day;
  }

  return aDatetimeDate;
}
function CharToNumberWithCheck(c, failures){
  var val;

  if(charIsNumber(c)){
    val = nGetNumberFromNumberCharacterForBase(c, 10);
  }else{
    val = 0;
    failures.numberValue = failures.numberValue + 1;
  }

  return val;
}
function test1(){
  var failures;
  failures = CreateNumberReference(0);

  AssertTrue(IsValidNorwegianPersonalIdentificationNumber("10061270707".split('')), failures);

  return failures.numberValue;
}
function test(){
  var failures;
  failures = 0;

  failures = failures + test1();

  return failures;
}
function CreateBooleanReference(value){
  var ref;
  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;
  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;
  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;
  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;
  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;
  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;
  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;
  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function nCreateStringDecimalFromNumber(decimal){
  var stringReference;
  stringReference = {};

  /* This will succeed because base = 10. */
  nCreateStringFromNumberWithCheck(decimal, 10, stringReference);

  return stringReference.string;
}
function nCreateStringFromNumberWithCheck(decimal, base, stringReference){
  var string;
  var maximumDigits;
  var digitPosition;
  var hasPrintedPoint;
  var i, d;
  var success;
  var characterReference;
  var c;
  if(decimal == 0){
    stringReference.string = "0".split('');
    success = true;
  }else{
    characterReference = {};
    if(IsInteger(base)){
      success = true;
      string = [];
      string.length = 0;
      maximumDigits = nGetMaximumDigitsForBase(base);
      digitPosition = nGetFirstDigitPosition(decimal, base);
      decimal = Math.round(decimal*Math.pow(base, maximumDigits - digitPosition - 1));
      hasPrintedPoint = false;
      if(digitPosition < 0){
        string = AppendCharacter(string, '0');
        string = AppendCharacter(string, '.');
        hasPrintedPoint = true;
        for(i = 0; i <  -digitPosition - 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }
      }
      for(i = 0; i < maximumDigits && success; i = i + 1){
        d = Math.floor(decimal/Math.pow(base, maximumDigits - i - 1));
        if( !hasPrintedPoint  && digitPosition - i + 1 == 0){
          if(decimal != 0){
            string = AppendCharacter(string, '.');
          }
          hasPrintedPoint = true;
        }
        if(decimal == 0 && hasPrintedPoint){
        }else{
          success = nGetSingleDigitCharacterFromNumberWithCheck(d, base, characterReference);
          if(success){
            c = characterReference.characterValue;
            string = AppendCharacter(string, c);
          }
        }
        if(success){
          decimal = decimal - d*Math.pow(base, maximumDigits - i - 1);
        }
      }
      if(success){
        for(i = 0; i < digitPosition - maximumDigits + 1; i = i + 1){
          string = AppendCharacter(string, '0');
        }
        stringReference.string = string;
      }
    }else{
      success = false;
    }
  }

  /* Done */
  return success;
}
function nGetMaximumDigitsForBase(base){
  var t;
  t = Math.pow(10, 15);
  return Math.floor(Math.log10(t)/Math.log10(base));
}
function nGetFirstDigitPosition(decimal, base){
  var power;
  var t;
  power = Math.ceil(Math.log10(decimal)/Math.log10(base));

  t = decimal*Math.pow(base,  -power);
  if(t < base && t >= 1){
  }else if(t >= base){
    power = power + 1;
  }else if(t < 1){
    power = power - 1;
  }

  return power;
}
function nGetSingleDigitCharacterFromNumberWithCheck(c, base, characterReference){
  var numberTable;
  var success;
  numberTable = nGetDigitCharacterTable();

  if(c < base || c < numberTable.length){
    success = true;
    characterReference.characterValue = numberTable[c];
  }else{
    success = false;
  }

  return success;
}
function nGetDigitCharacterTable(){
  var numberTable;
  numberTable = [];
  numberTable.length = 36;

  numberTable[0] = '0';
  numberTable[1] = '1';
  numberTable[2] = '2';
  numberTable[3] = '3';
  numberTable[4] = '4';
  numberTable[5] = '5';
  numberTable[6] = '6';
  numberTable[7] = '7';
  numberTable[8] = '8';
  numberTable[9] = '9';
  numberTable[10] = 'A';
  numberTable[11] = 'B';
  numberTable[12] = 'C';
  numberTable[13] = 'D';
  numberTable[14] = 'E';
  numberTable[15] = 'F';
  numberTable[16] = 'G';
  numberTable[17] = 'H';
  numberTable[18] = 'I';
  numberTable[19] = 'J';
  numberTable[20] = 'K';
  numberTable[21] = 'L';
  numberTable[22] = 'M';
  numberTable[23] = 'N';
  numberTable[24] = 'O';
  numberTable[25] = 'P';
  numberTable[26] = 'Q';
  numberTable[27] = 'R';
  numberTable[28] = 'S';
  numberTable[29] = 'T';
  numberTable[30] = 'U';
  numberTable[31] = 'V';
  numberTable[32] = 'W';
  numberTable[33] = 'X';
  numberTable[34] = 'Y';
  numberTable[35] = 'Z';

  return numberTable;
}
function nCreateNumberFromDecimalStringWithCheck(string, decimalReference, errorMessage){
  return nCreateNumberFromStringWithCheck(string, 10, decimalReference, errorMessage);
}
function nCreateNumberFromDecimalString(string){
  var doubleReference;
  var stringReference;
  var number;
  doubleReference = CreateNumberReference(0);
  stringReference = CreateStringReference("".split(''));
  nCreateNumberFromStringWithCheck(string, 10, doubleReference, stringReference);
  number = doubleReference.numberValue;

  delete(doubleReference);
  delete(stringReference);

  return number;
}
function nCreateNumberFromStringWithCheck(string, base, decimalReference, errorMessage){
  var c;
  var i, j;
  var isPositive;
  var beforeDecimalPoint, afterDecimalPoint;
  var n, validCharacters, d;
  var success;
  success = true;
  i = 0;
  isPositive = true;
  beforeDecimalPoint = 0;
  afterDecimalPoint = 0;
  n = 0;
  validCharacters = 0;

  if(base >= 2 && base <= 36){
    for(j = 0; j < string.length; j = j + 1){
      c = string[j];
      if(nCharacterIsNumberCharacterInBase(c, base) || c == '.' || c == '-'){
        validCharacters = validCharacters + 1;
      }
    }
    if(validCharacters == string.length){
      if(string.length > 0){
        c = string[i];
        if(c == '-'){
          isPositive = false;
          i = i + 1;
        }
        if(i < string.length){
          c = string[i];
          if(nCharacterIsNumberCharacterInBase(c, base)){
            for(; nCharacterIsNumberCharacterInBase(c, base) && (i < string.length); ){
              beforeDecimalPoint = beforeDecimalPoint + 1;
              i = i + 1;
              if(i < string.length){
                c = string[i];
              }
            }
            if(i < string.length){
              c = string[i];
              if(c == '.'){
                i = i + 1;
                if(i < string.length){
                  c = string[i];
                  for(; nCharacterIsNumberCharacterInBase(c, base) && (i < string.length); ){
                    afterDecimalPoint = afterDecimalPoint + 1;
                    i = i + 1;
                    if(i < string.length){
                      c = string[i];
                    }
                  }
                }else{
                  success = false;
                  errorMessage.string = "Number must have digits after the decimal point.".split('');
                }
              }
            }
          }else{
            success = false;
            errorMessage.string = "Number must start with digits (for negative numbers, after the negative sign).".split('');
          }
        }
        if(success != false){
          if(isPositive){
            i = 0;
          }else{
            i = 1;
          }
          for(j = 0; j < beforeDecimalPoint; j = j + 1){
            c = string[i];
            i = i + 1;
            d = nGetNumberFromNumberCharacterForBase(c, base);
            n = n + d*Math.pow(base, beforeDecimalPoint - j - 1);
          }
          if(afterDecimalPoint > 0){
            i = i + 1;
            for(j = 0; j < afterDecimalPoint; j = j + 1){
              c = string[i];
              i = i + 1;
              d = nGetNumberFromNumberCharacterForBase(c, base);
              n = n + d*Math.pow(base, 0 - j - 1);
            }
          }
          if( !isPositive ){
            n =  -n;
          }
          decimalReference.numberValue = n;
          success = true;
        }
      }else{
        success = false;
        errorMessage.string = "String has no content.".split('');
      }
    }else{
      success = false;
      errorMessage.string = "String contains invalid character.".split('');
    }
  }else{
    success = false;
    errorMessage.string = "Base must be from 2 to 36.".split('');
  }

  return success;
}
function nGetNumberFromNumberCharacterForBase(c, base){
  var numberTable;
  var i;
  var position;
  numberTable = nGetDigitCharacterTable();
  position = 0;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      position = i;
    }
  }

  return position;
}
function nCharacterIsNumberCharacterInBase(c, base){
  var numberTable;
  var i;
  var found;
  numberTable = nGetDigitCharacterTable();
  found = false;

  for(i = 0; i < base; i = i + 1){
    if(numberTable[i] == c){
      found = true;
    }
  }

  return found;
}
function nStringToNumberArray(str){
  var numberArrayReference;
  var stringReference;
  var numbers;
  numberArrayReference = {};
  stringReference = {};

  nStringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

  numbers = numberArrayReference.numberArray;

  delete(numberArrayReference);
  delete(stringReference);

  return numbers;
}
function nStringToNumberArrayWithCheck(str, numberArrayReference, errorMessage){
  var numberStrings;
  var numbers;
  var i;
  var numberString, trimmedNumberString;
  var success;
  var numberReference;
  numberStrings = SplitByString(str, ",".split(''));

  numbers = [];
  numbers.length = numberStrings.length;
  success = true;
  numberReference = {};

  for(i = 0; i < numberStrings.length; i = i + 1){
    numberString = numberStrings[i].string;
    trimmedNumberString = Trim(numberString);
    success = nCreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
    numbers[i] = numberReference.numberValue;
    FreeStringReference(numberStrings[i]);
    delete(trimmedNumberString);
  }

  delete(numberStrings);
  delete(numberReference);

  numberArrayReference.numberArray = numbers;

  return success;
}
function datetimeCreateDate(year, month, day){
  var date;
  date = {};

  date.year = year;
  date.month = month;
  date.day = day;

  return date;
}
function datetimeIsLeapYearWithCheck(year, isLeapYearReference, errorMessage){
  var itIsLeapYear;
  var success;
  if(year >= 1752){
    success = true;
    itIsLeapYear = datetimeIsLeapYear(year);
  }else{
    success = false;
    itIsLeapYear = false;
    errorMessage.string = "Gregorian calendar was not in general use.".split('');
  }

  isLeapYearReference.booleanValue = itIsLeapYear;
  return success;
}
function datetimeIsLeapYear(year){
  var itIsLeapYear;
  if(DivisibleBy(year, 4)){
    if(DivisibleBy(year, 100)){
      if(DivisibleBy(year, 400)){
        itIsLeapYear = true;
      }else{
        itIsLeapYear = false;
      }
    }else{
      itIsLeapYear = true;
    }
  }else{
    itIsLeapYear = false;
  }

  return itIsLeapYear;
}
function datetimeDayToDateWithCheck(dayNr, dateReference, errorMessage){
  var date;
  var remainder;
  var success;
  if(dayNr >=  -79623){
    date = {};
    remainder = {};
    remainder.numberValue = dayNr + 79623;
    date.year = datetimeGetYearFromDayNr(remainder.numberValue, remainder);
    date.month = datetimeGetMonthFromDayNr(remainder.numberValue, date.year, remainder);
    date.day = 1 + remainder.numberValue;
    dateReference.date = date;
    success = true;
  }else{
    success = false;
    errorMessage.string = "Gregorian calendar was not in general use before 1752.".split('');
  }

  return success;
}
function datetimeGetMonthFromDayNrWithCheck(dayNr, year, monthReference, remainderReference, errorMessage){
  var month;
  var success;
  if(dayNr >=  -79623){
    month = datetimeGetMonthFromDayNr(dayNr, year, remainderReference);
    monthReference.numberValue = month;
    success = true;
  }else{
    success = false;
    errorMessage.string = "Gregorian calendar not in general use before 1752.".split('');
  }

  return success;
}
function datetimeGetMonthFromDayNr(dayNr, year, remainderReference){
  var daysInMonth;
  var done;
  var month;
  daysInMonth = datetimeGetDaysInMonth(year);
  done = false;
  month = 1;

  for(;  !done ; ){
    if(dayNr > daysInMonth[month]){
      dayNr = dayNr - daysInMonth[month];
      month = month + 1;
    }else{
      done = true;
    }
  }
  remainderReference.numberValue = dayNr;

  return month;
}
function datetimeGetYearFromDayNrWithCheck(dayNr, yearReference, remainder, errorMessage){
  var success;
  var year;
  if(dayNr >= 0){
    success = true;
    year = datetimeGetYearFromDayNr(dayNr, remainder);
    yearReference.numberValue = year;
  }else{
    success = false;
    errorMessage.string = "Day number must be 0 or higher. 0 is 1752-01-01.".split('');
  }

  return success;
}
function datetimeGetYearFromDayNr(dayNr, remainder){
  var nrOfDays;
  var done;
  var year;
  done = false;
  year = 1752;

  for(;  !done ; ){
    if(datetimeIsLeapYear(year)){
      nrOfDays = 366;
    }else{
      nrOfDays = 365;
    }
    if(dayNr >= nrOfDays){
      dayNr = dayNr - nrOfDays;
      year = year + 1;
    }else{
      done = true;
    }
  }
  remainder.numberValue = dayNr;

  return year;
}
function datetimeDaysBetweenDates(A, B){
  var daysA, daysB, daysBetween;
  daysA = datetimeDateToDays(A);
  daysB = datetimeDateToDays(B);

  daysBetween = daysB - daysA;

  return daysBetween;
}
function datetimeGetDaysInMonthWithCheck(year, daysInMonthReference, errorMessage){
  var daysInMonth;
  var success;
  var date;
  date = datetimeCreateDate(year, 1, 1);

  success = datetimeIsValidDate(date, errorMessage);
  if(success){
    daysInMonth = datetimeGetDaysInMonth(year);
    daysInMonthReference.numberArray = daysInMonth;
  }

  return success;
}
function datetimeGetDaysInMonth(year){
  var daysInMonth;
  daysInMonth = [];
  daysInMonth.length = 1 + 12;

  daysInMonth[0] = 0;
  daysInMonth[1] = 31;

  if(datetimeIsLeapYear(year)){
    daysInMonth[2] = 29;
  }else{
    daysInMonth[2] = 28;
  }
  daysInMonth[3] = 31;
  daysInMonth[4] = 30;
  daysInMonth[5] = 31;
  daysInMonth[6] = 30;
  daysInMonth[7] = 31;
  daysInMonth[8] = 31;
  daysInMonth[9] = 30;
  daysInMonth[10] = 31;
  daysInMonth[11] = 30;
  daysInMonth[12] = 31;

  return daysInMonth;
}
function datetimeDateToDaysWithCheck(date, dayNumberReferenceReference, errorMessage){
  var days;
  var success;
  success = datetimeIsValidDate(date, errorMessage);
  if(success){
    days = datetimeDateToDays(date);
    dayNumberReferenceReference.numberValue = days;
  }

  return success;
}
function datetimeDateToDays(date){
  var days;
  days =  -79623;

  days = days + datetimeDaysInYears(date.year);
  days = days + datetimeDaysInMonths(date.month, date.year);
  days = days + date.day - 1;

  return days;
}
function datetimeDateToWeekdayNumberWithCheck(date, weekDayNumberReference, errorMessage){
  var weekDay;
  var success;
  success = datetimeIsValidDate(date, errorMessage);
  if(success){
    weekDay = datetimeDateToWeekdayNumber(date);
    weekDayNumberReference.numberValue = weekDay;
  }

  return success;
}
function datetimeDateToWeekdayNumber(date){
  var days, weekDay;
  days = datetimeDateToDays(date);

  days = days + 79623;
  days = days + 5;

  weekDay = days%7 + 1;

  return weekDay;
}
function datetimeDaysInMonthsWithCheck(month, year, daysInMonthsReference, errorMessage){
  var days;
  var success;
  var date;
  date = datetimeCreateDate(year, month, 1);

  success = datetimeIsValidDate(date, errorMessage);
  if(success){
    days = datetimeDaysInMonths(month, year);
    daysInMonthsReference.numberValue = days;
  }

  return success;
}
function datetimeDaysInMonths(month, year){
  var daysInMonth;
  var days;
  var i;
  daysInMonth = datetimeGetDaysInMonth(year);

  days = 0;
  for(i = 1; i < month; i = i + 1){
    days = days + daysInMonth[i];
  }

  return days;
}
function datetimeDaysInYearsWithCheck(years, daysReference, errorMessage){
  var days;
  var success;
  var date;
  date = datetimeCreateDate(years, 1, 1);

  success = datetimeIsValidDate(date, errorMessage);
  if(success){
    days = datetimeDaysInYears(years);
    daysReference.numberValue = days;
  }

  return success;
}
function datetimeDaysInYears(years){
  var days;
  var i;
  var nrOfDays;
  days = 0;
  for(i = 1752; i < years; i = i + 1){
    if(datetimeIsLeapYear(i)){
      nrOfDays = 366;
    }else{
      nrOfDays = 365;
    }
    days = days + nrOfDays;
  }

  return days;
}
function datetimeIsValidDate(date, errorMessage){
  var valid;
  var daysInMonth;
  var daysInThisMonth;
  if(date.year >= 1752){
    if(date.month >= 1 && date.month <= 12){
      daysInMonth = datetimeGetDaysInMonth(date.year);
      daysInThisMonth = daysInMonth[date.month];
      if(date.day >= 1 && date.day <= daysInThisMonth){
        valid = true;
      }else{
        valid = false;
        errorMessage.string = "The month does not have the given day number.".split('');
      }
    }else{
      valid = false;
      errorMessage.string = "Month must be between 1 and 12, inclusive.".split('');
    }
  }else{
    valid = false;
    errorMessage.string = "Gregorian calendar was not in general use before 1752.".split('');
  }

  return valid;
}
function datetimeCreateDateTimeTimezone(year, month, day, hours, minutes, seconds, timezoneOffsetSeconds){
  var dateTimeTimezone;
  dateTimeTimezone = {};

  dateTimeTimezone.dateTime = datetimeCreateDateTime(year, month, day, hours, minutes, seconds);
  dateTimeTimezone.timezoneOffsetSeconds = timezoneOffsetSeconds;

  return dateTimeTimezone;
}
function datetimeCreateDateTimeTimezoneInHoursAndMinutes(year, month, day, hours, minutes, seconds, timezoneOffsetHours, timezoneOffsetMinutes){
  var dateTimeTimezone;
  dateTimeTimezone = {};

  dateTimeTimezone.dateTime = datetimeCreateDateTime(year, month, day, hours, minutes, seconds);
  dateTimeTimezone.timezoneOffsetSeconds = datetimeGetSecondsFromHours(timezoneOffsetHours) + datetimeGetSecondsFromMinutes(timezoneOffsetMinutes);

  return dateTimeTimezone;
}
function datetimeGetDateFromDateTimeTimeZone(dateTimeTimezone, dateTimeReference, errorMessage){
  var dateTime;
  dateTime = dateTimeTimezone.dateTime;

  return datetimeAddSecondsToDateTime(dateTime,  -dateTimeTimezone.timezoneOffsetSeconds, dateTimeReference, errorMessage);
}
function datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInSeconds(dateTime, timezoneOffsetSeconds, dateTimeTimezoneReference, errorMessage){
  var success;
  var adjustedDateTimeReference;
  var dateTimeTimezone;
  adjustedDateTimeReference = {};
  dateTimeTimezone = {};

  success = datetimeAddSecondsToDateTime(dateTime, timezoneOffsetSeconds, adjustedDateTimeReference, errorMessage);

  if(success){
    dateTimeTimezone.dateTime = adjustedDateTimeReference.dateTime;
    dateTimeTimezone.timezoneOffsetSeconds = timezoneOffsetSeconds;
    dateTimeTimezoneReference.dateTimeTimezone = dateTimeTimezone;
  }

  return success;
}
function datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInHoursAndMinutes(dateTime, timezoneOffsetHours, timezoneOffsetMinutes, dateTimeTimezoneReference, errorMessage){
  return datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInSeconds(dateTime, datetimeGetSecondsFromHours(timezoneOffsetHours) + datetimeGetSecondsFromMinutes(timezoneOffsetMinutes), dateTimeTimezoneReference, errorMessage);
}
function datetimeCreateDateTime(year, month, day, hours, minutes, seconds){
  var dateTime;
  dateTime = {};

  dateTime.date = datetimeCreateDate(year, month, day);
  dateTime.hours = hours;
  dateTime.minutes = minutes;
  dateTime.seconds = seconds;

  return dateTime;
}
function datetimeGetDateTimeFromSeconds(seconds, dateTimeReference, errorMessage){
  var dateTime;
  var secondsInMinute, secondsInHour, secondsInDay, days, remainder;
  var date;
  var dateReference;
  var success;
  secondsInMinute = 60;
  secondsInHour = 60*secondsInMinute;
  secondsInDay = 24*secondsInHour;
  days = Math.floor(seconds/secondsInDay);
  remainder = seconds - days*secondsInDay;
  dateReference = {};

  success = datetimeDayToDateWithCheck(days, dateReference, errorMessage);
  if(success){
    date = dateReference.date;
    dateTime = {};
    dateTime.date = date;
    dateTime.hours = Math.floor(remainder/secondsInHour);
    remainder = remainder - dateTime.hours*secondsInHour;
    dateTime.minutes = Math.floor(remainder/secondsInMinute);
    remainder = remainder - dateTime.minutes*secondsInMinute;
    dateTime.seconds = remainder;
    dateTimeReference.dateTime = dateTime;
  }

  return success;
}
function datetimeGetSecondsFromDateTime(dateTime){
  var seconds;
  var days;
  var secondsInMinute;
  var secondsInHour;
  var secondsInDay;
  var dayNumberReferenceReference;
  var errorMessage;
  var success;
  seconds = 0;
  dayNumberReferenceReference = {};
  errorMessage = {};

  success = datetimeDateToDaysWithCheck(dateTime.date, dayNumberReferenceReference, errorMessage);
  if(success){
    days = dayNumberReferenceReference.numberValue;
    secondsInMinute = 60;
    secondsInHour = 60*secondsInMinute;
    secondsInDay = 24*secondsInHour;
    seconds = seconds + secondsInDay*days;
    seconds = seconds + secondsInHour*dateTime.hours;
    seconds = seconds + secondsInMinute*dateTime.minutes;
    seconds = seconds + dateTime.seconds;
  }

  return seconds;
}
function datetimeGetSecondsFromMinutes(minutes){
  return minutes*60;
}
function datetimeGetSecondsFromHours(hours){
  return datetimeGetSecondsFromMinutes(hours*60);
}
function datetimeGetSecondsFromDays(days){
  return datetimeGetSecondsFromHours(days*24);
}
function datetimeGetSecondsFromWeeks(weeks){
  return datetimeGetSecondsFromDays(weeks*7);
}
function datetimeGetMinutesFromSeconds(seconds){
  return seconds/60;
}
function datetimeGetHoursFromSeconds(seconds){
  return datetimeGetMinutesFromSeconds(seconds)/60;
}
function datetimeGetDaysFromSeconds(seconds){
  return datetimeGetHoursFromSeconds(seconds)/24;
}
function datetimeGetWeeksFromSeconds(seconds){
  return datetimeGetDaysFromSeconds(seconds)/7;
}
function datetimeGetDateFromDateTime(dateTime){
  return dateTime.date;
}
function datetimeAddSecondsToDateTime(dateTime, seconds, dateTimeReference, errorMessage){
  var secondsInDateTime;
  secondsInDateTime = datetimeGetSecondsFromDateTime(dateTime);
  secondsInDateTime = secondsInDateTime + seconds;

  return datetimeGetDateTimeFromSeconds(secondsInDateTime, dateTimeReference, errorMessage);
}
function datetimeAddMinutesToDateTime(dateTime, minutes, dateTimeReference, errorMessage){
  return datetimeAddSecondsToDateTime(dateTime, datetimeGetSecondsFromMinutes(minutes), dateTimeReference, errorMessage);
}
function datetimeAddHoursToDateTime(dateTime, minutes, dateTimeReference, errorMessage){
  return datetimeAddSecondsToDateTime(dateTime, datetimeGetSecondsFromHours(minutes), dateTimeReference, errorMessage);
}
function datetimeAddDaysToDateTime(dateTime, days, dateTimeReference, errorMessage){
  return datetimeAddSecondsToDateTime(dateTime, datetimeGetSecondsFromDays(days), dateTimeReference, errorMessage);
}
function datetimeAddWeeksToDateTime(dateTime, weeks, dateTimeReference, errorMessage){
  return datetimeAddSecondsToDateTime(dateTime, datetimeGetSecondsFromWeeks(weeks), dateTimeReference, errorMessage);
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;
  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function StringToNumberArray(string){
  var i;
  var array;
  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;
  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;
  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;
  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = from; i < to; i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = Math.max(from, 0); i < Math.min(to, a.length); i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringInterval(a, value, from, to){
  var i;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length){
    for(i = Math.max(from, 0); i < Math.min(to, a.length); i = i + 1){
      a[i] = value;
    }
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;
  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;
  if(from >= 0 && from < a.length && to >= 0 && to < a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;
    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }
    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;
  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SubstringWithCheck(string, from, to, stringReference){
  var success;
  if(from < string.length && to < string.length && from <= to && from >= 0 && to >= 0){
    stringReference.string = Substring(string, from, to);
    success = true;
  }else{
    success = false;
  }

  return success;
}
function Substring(string, from, to){
  var n;
  var i;
  n = [];
  n.length = Math.max(to - from, 0);

  for(i = from; i < to; i = i + 1){
    n[i - from] = string[i];
  }

  return n;
}
function AppendString(string, s){
  var newString;
  newString = ConcatenateString(string, s);

  delete(string);

  return newString;
}
function ConcatenateString(string, s){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + s.length;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  for(i = 0; i < s.length; i = i + 1){
    newString[string.length + i] = s[i];
  }

  return newString;
}
function AppendCharacter(string, c){
  var newString;
  newString = ConcatenateCharacter(string, c);

  delete(string);

  return newString;
}
function ConcatenateCharacter(string, c){
  var newString;
  var i;
  newString = [];
  newString.length = string.length + 1;

  for(i = 0; i < string.length; i = i + 1){
    newString[i] = string[i];
  }

  newString[string.length] = c;

  return newString;
}
function SplitByCharacter(toSplit, splitBy){
  var split;
  var stringToSplitBy;
  stringToSplitBy = [];
  stringToSplitBy.length = 1;
  stringToSplitBy[0] = splitBy;

  split = SplitByString(toSplit, stringToSplitBy);

  delete(stringToSplitBy);

  return split;
}
function IndexOfCharacter(string, character, indexReference){
  var i;
  var found;
  found = false;
  for(i = 0; i < string.length &&  !found ; i = i + 1){
    if(string[i] == character){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function SubstringEqualsWithCheck(string, from, substring, equalsReference){
  var success;
  if(from < string.length){
    success = true;
    equalsReference.booleanValue = SubstringEquals(string, from, substring);
  }else{
    success = false;
  }

  return success;
}
function SubstringEquals(string, from, substring){
  var i;
  var equal;
  equal = true;
  for(i = 0; i < substring.length && equal; i = i + 1){
    if(string[from + i] != substring[i]){
      equal = false;
    }
  }

  return equal;
}
function IndexOfString(string, substring, indexReference){
  var i;
  var found;
  found = false;
  for(i = 0; i < string.length - substring.length + 1 &&  !found ; i = i + 1){
    if(SubstringEquals(string, i, substring)){
      found = true;
      indexReference.numberValue = i;
    }
  }

  return found;
}
function ContainsCharacter(string, character){
  return IndexOfCharacter(string, character, {});
}
function ContainsString(string, substring){
  return IndexOfString(string, substring, {});
}
function ToUpperCase(string){
  var i;
  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToUpperCase(string[i]);
  }
}
function ToLowerCase(string){
  var i;
  for(i = 0; i < string.length; i = i + 1){
    string[i] = charToLowerCase(string[i]);
  }
}
function EqualsIgnoreCase(a, b){
  var equal;
  var i;
  if(a.length == b.length){
    equal = true;
    for(i = 0; i < a.length && equal; i = i + 1){
      if(charToLowerCase(a[i]) != charToLowerCase(b[i])){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function ReplacesString(string, toReplace, replaceWith){
  var result;
  var i;
  var equalsReference;
  var success;
  equalsReference = {};
  result = [];
  result.length = 0;

  for(i = 0; i < string.length; ){
    success = SubstringEqualsWithCheck(string, i, toReplace, equalsReference);
    if(success){
      success = equalsReference.booleanValue;
    }
    if(success && toReplace.length > 0){
      result = ConcatenateString(result, replaceWith);
      i = i + toReplace.length;
    }else{
      result = ConcatenateCharacter(result, string[i]);
      i = i + 1;
    }
  }

  return result;
}
function ReplaceCharacter(string, toReplace, replaceWith){
  var result;
  var i;
  result = [];
  result.length = 0;

  for(i = 0; i < string.length; i = i + 1){
    if(string[i] == toReplace){
      result = ConcatenateCharacter(result, replaceWith);
    }else{
      result = ConcatenateCharacter(result, string[i]);
    }
  }

  return result;
}
function Trim(string){
  var result;
  var i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
  var firstNonWhitespaceFound;
  lastWhitespaceLocationStart =  -1;
  firstNonWhitespaceFound = false;
  for(i = 0; i < string.length &&  !firstNonWhitespaceFound ; i = i + 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationStart = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  /* Find whitepaces at the end. */
  lastWhitespaceLocationEnd = string.length;
  firstNonWhitespaceFound = false;
  for(i = string.length - 1; i >= 0 &&  !firstNonWhitespaceFound ; i = i - 1){
    if(charIsWhiteSpace(string[i])){
      lastWhitespaceLocationEnd = i;
    }else{
      firstNonWhitespaceFound = true;
    }
  }

  if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
    result = Substring(string, lastWhitespaceLocationStart + 1, lastWhitespaceLocationEnd);
  }else{
    result = [];
    result.length = 0;
  }

  return result;
}
function StartsWith(string, start){
  var startsWithString;
  startsWithString = false;
  if(string.length >= start.length){
    startsWithString = SubstringEquals(string, 0, start);
  }

  return startsWithString;
}
function EndsWith(string, end){
  var endsWithString;
  endsWithString = false;
  if(string.length >= end.length){
    endsWithString = SubstringEquals(string, string.length - end.length, end);
  }

  return endsWithString;
}
function SplitByString(toSplit, splitBy){
  var split;
  var next;
  var i;
  var c;
  var n;
  split = [];
  split.length = 0;

  next = [];
  next.length = 0;
  for(i = 0; i < toSplit.length; ){
    c = toSplit[i];
    if(SubstringEquals(toSplit, i, splitBy)){
      if(split.length != 0 || i != 0){
        n = {};
        n.string = next;
        split = AddString(split, n);
        next = [];
        next.length = 0;
        i = i + splitBy.length;
      }
    }else{
      next = AppendCharacter(next, c);
      i = i + 1;
    }
  }

  if(next.length > 0){
    n = {};
    n.string = next;
    split = AddString(split, n);
  }

  return split;
}
function Negate(x){
  return  -x;
}
function Positive(x){
  return  +x;
}
function Factorial(x){
  var i, f;
  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function Round(x){
  return Math.floor(x + 0.5);
}
function BankersRound(x){
  var r;
  if(Absolute(x - Truncate(x)) == 0.5){
    if( !DivisibleBy(Round(x), 2) ){
      r = Round(x) - 1;
    }else{
      r = Round(x);
    }
  }else{
    r = Round(x);
  }

  return r;
}
function Ceil(x){
  return Math.ceil(x);
}
function Floor(x){
  return Math.floor(x);
}
function Truncate(x){
  var t;
  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function Absolute(x){
  return Math.abs(x);
}
function Logarithm(x){
  return Math.log10(x);
}
function NaturalLogarithm(x){
  return Math.log(x);
}
function Sin(x){
  return Math.sin(x);
}
function Cos(x){
  return Math.cos(x);
}
function Tan(x){
  return Math.tan(x);
}
function Asin(x){
  return Math.asin(x);
}
function Acos(x){
  return Math.acos(x);
}
function Atan(x){
  return Math.atan(x);
}
function Atan2(y, x){
  var a;
  a = 0;

  if(x > 0){
    a = Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function Squareroot(x){
  return Math.sqrt(x);
}
function Exp(x){
  return Math.exp(x);
}
function DivisibleBy(a, b){
  return ((a%b) == 0);
}
function Combinations(n, k){
  return Factorial(n)/(Factorial(n - k)*Factorial(k));
}
function EpsilonCompareApproximateDigits(a, b, digits){
  var ad, bd, d, epsilon;
  var ret;
  if(a < 0 && b < 0 || a > 0 && b > 0){
    if(a < 0 && b < 0){
      a =  -a;
      b =  -b;
    }
    ad = Math.log10(a);
    bd = Math.log10(b);
    d = Math.max(ad, bd);
    epsilon = Math.pow(10, d - digits);
    ret = Math.abs(a - b) > epsilon;
  }else{
    ret = false;
  }

  return ret;
}
function EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function GreatestCommonDivisor(a, b){
  var t;
  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;
  if(IsInteger(a) && IsInteger(b)){
    gcd = GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultiple(a, b){
  var lcm;
  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function Sign(a){
  var s;
  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function Max(a, b){
  return Math.max(a, b);
}
function Min(a, b){
  return Math.min(a, b);
}
function Power(a, b){
  return Math.pow(a, b);
}
function AddNumber(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function AddBoolean(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }
		
  delete(list);
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function AddCharacter(list, a){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;
  newlist = [];
  newlist.length = list.length - 1;

  for(i = 0; i < list.length; i = i + 1){
    if(i < n){
      newlist[i] = list[i];
    }
    if(i > n){
      newlist[i - 1] = list[i];
    }
  }

  delete(list);

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function charToLowerCase(character){
  var toReturn;
  toReturn = character;
  if(character == 'A'){
    toReturn = 'a';
  }else if(character == 'B'){
    toReturn = 'b';
  }else if(character == 'C'){
    toReturn = 'c';
  }else if(character == 'D'){
    toReturn = 'd';
  }else if(character == 'E'){
    toReturn = 'e';
  }else if(character == 'F'){
    toReturn = 'f';
  }else if(character == 'G'){
    toReturn = 'g';
  }else if(character == 'H'){
    toReturn = 'h';
  }else if(character == 'I'){
    toReturn = 'i';
  }else if(character == 'J'){
    toReturn = 'j';
  }else if(character == 'K'){
    toReturn = 'k';
  }else if(character == 'L'){
    toReturn = 'l';
  }else if(character == 'M'){
    toReturn = 'm';
  }else if(character == 'N'){
    toReturn = 'n';
  }else if(character == 'O'){
    toReturn = 'o';
  }else if(character == 'P'){
    toReturn = 'p';
  }else if(character == 'Q'){
    toReturn = 'q';
  }else if(character == 'R'){
    toReturn = 'r';
  }else if(character == 'S'){
    toReturn = 's';
  }else if(character == 'T'){
    toReturn = 't';
  }else if(character == 'U'){
    toReturn = 'u';
  }else if(character == 'V'){
    toReturn = 'v';
  }else if(character == 'W'){
    toReturn = 'w';
  }else if(character == 'X'){
    toReturn = 'x';
  }else if(character == 'Y'){
    toReturn = 'y';
  }else if(character == 'Z'){
    toReturn = 'z';
  }

  return toReturn;
}
function charToUpperCase(character){
  var toReturn;
  toReturn = character;
  if(character == 'a'){
    toReturn = 'A';
  }else if(character == 'b'){
    toReturn = 'B';
  }else if(character == 'c'){
    toReturn = 'C';
  }else if(character == 'd'){
    toReturn = 'D';
  }else if(character == 'e'){
    toReturn = 'E';
  }else if(character == 'f'){
    toReturn = 'F';
  }else if(character == 'g'){
    toReturn = 'G';
  }else if(character == 'h'){
    toReturn = 'H';
  }else if(character == 'i'){
    toReturn = 'I';
  }else if(character == 'j'){
    toReturn = 'J';
  }else if(character == 'k'){
    toReturn = 'K';
  }else if(character == 'l'){
    toReturn = 'L';
  }else if(character == 'm'){
    toReturn = 'M';
  }else if(character == 'n'){
    toReturn = 'N';
  }else if(character == 'o'){
    toReturn = 'O';
  }else if(character == 'p'){
    toReturn = 'P';
  }else if(character == 'q'){
    toReturn = 'Q';
  }else if(character == 'r'){
    toReturn = 'R';
  }else if(character == 's'){
    toReturn = 'S';
  }else if(character == 't'){
    toReturn = 'T';
  }else if(character == 'u'){
    toReturn = 'U';
  }else if(character == 'v'){
    toReturn = 'V';
  }else if(character == 'w'){
    toReturn = 'W';
  }else if(character == 'x'){
    toReturn = 'X';
  }else if(character == 'y'){
    toReturn = 'Y';
  }else if(character == 'z'){
    toReturn = 'Z';
  }

  return toReturn;
}
function charIsUpperCase(character){
  var isUpper;
  isUpper = false;
  if(character == 'A'){
    isUpper = true;
  }else if(character == 'B'){
    isUpper = true;
  }else if(character == 'C'){
    isUpper = true;
  }else if(character == 'D'){
    isUpper = true;
  }else if(character == 'E'){
    isUpper = true;
  }else if(character == 'F'){
    isUpper = true;
  }else if(character == 'G'){
    isUpper = true;
  }else if(character == 'H'){
    isUpper = true;
  }else if(character == 'I'){
    isUpper = true;
  }else if(character == 'J'){
    isUpper = true;
  }else if(character == 'K'){
    isUpper = true;
  }else if(character == 'L'){
    isUpper = true;
  }else if(character == 'M'){
    isUpper = true;
  }else if(character == 'N'){
    isUpper = true;
  }else if(character == 'O'){
    isUpper = true;
  }else if(character == 'P'){
    isUpper = true;
  }else if(character == 'Q'){
    isUpper = true;
  }else if(character == 'R'){
    isUpper = true;
  }else if(character == 'S'){
    isUpper = true;
  }else if(character == 'T'){
    isUpper = true;
  }else if(character == 'U'){
    isUpper = true;
  }else if(character == 'V'){
    isUpper = true;
  }else if(character == 'W'){
    isUpper = true;
  }else if(character == 'X'){
    isUpper = true;
  }else if(character == 'Y'){
    isUpper = true;
  }else if(character == 'Z'){
    isUpper = true;
  }

  return isUpper;
}
function charIsLowerCase(character){
  var isLower;
  isLower = false;
  if(character == 'a'){
    isLower = true;
  }else if(character == 'b'){
    isLower = true;
  }else if(character == 'c'){
    isLower = true;
  }else if(character == 'd'){
    isLower = true;
  }else if(character == 'e'){
    isLower = true;
  }else if(character == 'f'){
    isLower = true;
  }else if(character == 'g'){
    isLower = true;
  }else if(character == 'h'){
    isLower = true;
  }else if(character == 'i'){
    isLower = true;
  }else if(character == 'j'){
    isLower = true;
  }else if(character == 'k'){
    isLower = true;
  }else if(character == 'l'){
    isLower = true;
  }else if(character == 'm'){
    isLower = true;
  }else if(character == 'n'){
    isLower = true;
  }else if(character == 'o'){
    isLower = true;
  }else if(character == 'p'){
    isLower = true;
  }else if(character == 'q'){
    isLower = true;
  }else if(character == 'r'){
    isLower = true;
  }else if(character == 's'){
    isLower = true;
  }else if(character == 't'){
    isLower = true;
  }else if(character == 'u'){
    isLower = true;
  }else if(character == 'v'){
    isLower = true;
  }else if(character == 'w'){
    isLower = true;
  }else if(character == 'x'){
    isLower = true;
  }else if(character == 'y'){
    isLower = true;
  }else if(character == 'z'){
    isLower = true;
  }

  return isLower;
}
function charIsLetter(character){
  return charIsUpperCase(character) || charIsLowerCase(character);
}
function charIsNumber(character){
  var isNumber;
  isNumber = false;
  if(character == '0'){
    isNumber = true;
  }else if(character == '1'){
    isNumber = true;
  }else if(character == '2'){
    isNumber = true;
  }else if(character == '3'){
    isNumber = true;
  }else if(character == '4'){
    isNumber = true;
  }else if(character == '5'){
    isNumber = true;
  }else if(character == '6'){
    isNumber = true;
  }else if(character == '7'){
    isNumber = true;
  }else if(character == '8'){
    isNumber = true;
  }else if(character == '9'){
    isNumber = true;
  }

  return isNumber;
}
function charIsWhiteSpace(character){
  var isWhiteSpace;
  isWhiteSpace = false;
  if(character == ' '){
    isWhiteSpace = true;
  }else if(character == '\t'){
    isWhiteSpace = true;
  }else if(character == '\n'){
    isWhiteSpace = true;
  }else if(character == '\r'){
    isWhiteSpace = true;
  }

  return isWhiteSpace;
}
function charIsSymbol(character){
  var isSymbol;
  isSymbol = false;
  if(character == '!'){
    isSymbol = true;
  }else if(character == '\"'){
    isSymbol = true;
  }else if(character == '#'){
    isSymbol = true;
  }else if(character == '$'){
    isSymbol = true;
  }else if(character == '%'){
    isSymbol = true;
  }else if(character == '&'){
    isSymbol = true;
  }else if(character == '\''){
    isSymbol = true;
  }else if(character == '('){
    isSymbol = true;
  }else if(character == ')'){
    isSymbol = true;
  }else if(character == '*'){
    isSymbol = true;
  }else if(character == '+'){
    isSymbol = true;
  }else if(character == ','){
    isSymbol = true;
  }else if(character == '-'){
    isSymbol = true;
  }else if(character == '.'){
    isSymbol = true;
  }else if(character == '/'){
    isSymbol = true;
  }else if(character == ':'){
    isSymbol = true;
  }else if(character == ';'){
    isSymbol = true;
  }else if(character == '<'){
    isSymbol = true;
  }else if(character == '='){
    isSymbol = true;
  }else if(character == '>'){
    isSymbol = true;
  }else if(character == '?'){
    isSymbol = true;
  }else if(character == '@'){
    isSymbol = true;
  }else if(character == '['){
    isSymbol = true;
  }else if(character == '\\'){
    isSymbol = true;
  }else if(character == ']'){
    isSymbol = true;
  }else if(character == '^'){
    isSymbol = true;
  }else if(character == '_'){
    isSymbol = true;
  }else if(character == '`'){
    isSymbol = true;
  }else if(character == '{'){
    isSymbol = true;
  }else if(character == '|'){
    isSymbol = true;
  }else if(character == '}'){
    isSymbol = true;
  }else if(character == '~'){
    isSymbol = true;
  }

  return isSymbol;
}


module.exports = {
	IsValidNorwegianPersonalIdentificationNumber: IsValidNorwegianPersonalIdentificationNumber,
	GetDateFromNorwegianPersonalIdentificationNumber: GetDateFromNorwegianPersonalIdentificationNumber,
	CharToNumberWithCheck: CharToNumberWithCheck,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	nCreateStringDecimalFromNumber: nCreateStringDecimalFromNumber,
	nCreateStringFromNumberWithCheck: nCreateStringFromNumberWithCheck,
	nGetMaximumDigitsForBase: nGetMaximumDigitsForBase,
	nGetFirstDigitPosition: nGetFirstDigitPosition,
	nGetSingleDigitCharacterFromNumberWithCheck: nGetSingleDigitCharacterFromNumberWithCheck,
	nGetDigitCharacterTable: nGetDigitCharacterTable,
	nCreateNumberFromDecimalStringWithCheck: nCreateNumberFromDecimalStringWithCheck,
	nCreateNumberFromDecimalString: nCreateNumberFromDecimalString,
	nCreateNumberFromStringWithCheck: nCreateNumberFromStringWithCheck,
	nGetNumberFromNumberCharacterForBase: nGetNumberFromNumberCharacterForBase,
	nCharacterIsNumberCharacterInBase: nCharacterIsNumberCharacterInBase,
	nStringToNumberArray: nStringToNumberArray,
	nStringToNumberArrayWithCheck: nStringToNumberArrayWithCheck,
	datetimeCreateDate: datetimeCreateDate,
	datetimeIsLeapYearWithCheck: datetimeIsLeapYearWithCheck,
	datetimeIsLeapYear: datetimeIsLeapYear,
	datetimeDayToDateWithCheck: datetimeDayToDateWithCheck,
	datetimeGetMonthFromDayNrWithCheck: datetimeGetMonthFromDayNrWithCheck,
	datetimeGetMonthFromDayNr: datetimeGetMonthFromDayNr,
	datetimeGetYearFromDayNrWithCheck: datetimeGetYearFromDayNrWithCheck,
	datetimeGetYearFromDayNr: datetimeGetYearFromDayNr,
	datetimeDaysBetweenDates: datetimeDaysBetweenDates,
	datetimeGetDaysInMonthWithCheck: datetimeGetDaysInMonthWithCheck,
	datetimeGetDaysInMonth: datetimeGetDaysInMonth,
	datetimeDateToDaysWithCheck: datetimeDateToDaysWithCheck,
	datetimeDateToDays: datetimeDateToDays,
	datetimeDateToWeekdayNumberWithCheck: datetimeDateToWeekdayNumberWithCheck,
	datetimeDateToWeekdayNumber: datetimeDateToWeekdayNumber,
	datetimeDaysInMonthsWithCheck: datetimeDaysInMonthsWithCheck,
	datetimeDaysInMonths: datetimeDaysInMonths,
	datetimeDaysInYearsWithCheck: datetimeDaysInYearsWithCheck,
	datetimeDaysInYears: datetimeDaysInYears,
	datetimeIsValidDate: datetimeIsValidDate,
	datetimeCreateDateTimeTimezone: datetimeCreateDateTimeTimezone,
	datetimeCreateDateTimeTimezoneInHoursAndMinutes: datetimeCreateDateTimeTimezoneInHoursAndMinutes,
	datetimeGetDateFromDateTimeTimeZone: datetimeGetDateFromDateTimeTimeZone,
	datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInSeconds: datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInSeconds,
	datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInHoursAndMinutes: datetimeCreateDateTimeTimezoneFromDateTimeAndTimeZoneInHoursAndMinutes,
	datetimeCreateDateTime: datetimeCreateDateTime,
	datetimeGetDateTimeFromSeconds: datetimeGetDateTimeFromSeconds,
	datetimeGetSecondsFromDateTime: datetimeGetSecondsFromDateTime,
	datetimeGetSecondsFromMinutes: datetimeGetSecondsFromMinutes,
	datetimeGetSecondsFromHours: datetimeGetSecondsFromHours,
	datetimeGetSecondsFromDays: datetimeGetSecondsFromDays,
	datetimeGetSecondsFromWeeks: datetimeGetSecondsFromWeeks,
	datetimeGetMinutesFromSeconds: datetimeGetMinutesFromSeconds,
	datetimeGetHoursFromSeconds: datetimeGetHoursFromSeconds,
	datetimeGetDaysFromSeconds: datetimeGetDaysFromSeconds,
	datetimeGetWeeksFromSeconds: datetimeGetWeeksFromSeconds,
	datetimeGetDateFromDateTime: datetimeGetDateFromDateTime,
	datetimeAddSecondsToDateTime: datetimeAddSecondsToDateTime,
	datetimeAddMinutesToDateTime: datetimeAddMinutesToDateTime,
	datetimeAddHoursToDateTime: datetimeAddHoursToDateTime,
	datetimeAddDaysToDateTime: datetimeAddDaysToDateTime,
	datetimeAddWeeksToDateTime: datetimeAddWeeksToDateTime,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayInterval: FillNumberArrayInterval,
	FillBooleanArrayInterval: FillBooleanArrayInterval,
	FillStringInterval: FillStringInterval,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SubstringWithCheck: SubstringWithCheck,
	Substring: Substring,
	AppendString: AppendString,
	ConcatenateString: ConcatenateString,
	AppendCharacter: AppendCharacter,
	ConcatenateCharacter: ConcatenateCharacter,
	SplitByCharacter: SplitByCharacter,
	IndexOfCharacter: IndexOfCharacter,
	SubstringEqualsWithCheck: SubstringEqualsWithCheck,
	SubstringEquals: SubstringEquals,
	IndexOfString: IndexOfString,
	ContainsCharacter: ContainsCharacter,
	ContainsString: ContainsString,
	ToUpperCase: ToUpperCase,
	ToLowerCase: ToLowerCase,
	EqualsIgnoreCase: EqualsIgnoreCase,
	ReplacesString: ReplacesString,
	ReplaceCharacter: ReplaceCharacter,
	Trim: Trim,
	StartsWith: StartsWith,
	EndsWith: EndsWith,
	SplitByString: SplitByString,
	Negate: Negate,
	Positive: Positive,
	Factorial: Factorial,
	Round: Round,
	BankersRound: BankersRound,
	Ceil: Ceil,
	Floor: Floor,
	Truncate: Truncate,
	Absolute: Absolute,
	Logarithm: Logarithm,
	NaturalLogarithm: NaturalLogarithm,
	Sin: Sin,
	Cos: Cos,
	Tan: Tan,
	Asin: Asin,
	Acos: Acos,
	Atan: Atan,
	Atan2: Atan2,
	Squareroot: Squareroot,
	Exp: Exp,
	DivisibleBy: DivisibleBy,
	Combinations: Combinations,
	EpsilonCompareApproximateDigits: EpsilonCompareApproximateDigits,
	EpsilonCompare: EpsilonCompare,
	GreatestCommonDivisor: GreatestCommonDivisor,
	IsInteger: IsInteger,
	GreatestCommonDivisorWithCheck: GreatestCommonDivisorWithCheck,
	LeastCommonMultiple: LeastCommonMultiple,
	Sign: Sign,
	Max: Max,
	Min: Min,
	Power: Power,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	charToLowerCase: charToLowerCase,
	charToUpperCase: charToUpperCase,
	charIsUpperCase: charIsUpperCase,
	charIsLowerCase: charIsLowerCase,
	charIsLetter: charIsLetter,
	charIsNumber: charIsNumber,
	charIsWhiteSpace: charIsWhiteSpace,
	charIsSymbol: charIsSymbol,
	test: test
};